local mod = MorgDKP2:NewModule("Relational")
local L = LibStub("AceLocale-3.0"):GetLocale("MorgDKP2")
local media = LibStub("LibSharedMedia-3.0", true)
local BC = LibStub("LibBabble-Class-3.0"):GetLookupTable()

local mdkp = MorgDKP2 
	

--locals
local LL = LibStub("AceLocale-3.0"):NewLocale("Relational", "enUS", true)
	
if LL then
	LL["Relational DKP"] = true
	LL["Enable Relational DKP for calculating the earned/spent dkp ratio."] = true
end

local LL = LibStub("AceLocale-3.0"):GetLocale("Relational")

mod.modName = LL["Relational DKP"]
mod.modref = "Relational"

local Player = UnitName("player")
local db
local fmt = string.format
local floor = math.floor

local defaults = { 
	profile = {
		
	},
}

local options = {
		relationaldkp = {
			type = "toggle",
			name = LL["Relational DKP"],
			desc = LL["Enable Relational DKP for calculating the earned/spent dkp ratio."],
			get = function() return mdkp.db.profile.modules.Relational end,
			set = 	function(info, v) 
					mdkp.db.profile.modules.Relational = v
					if v then 
						--mod:Enable()
						mod:DKPChange(mod.modName)
					else 
						mod:Disable()
						mdkp.db.profile.currDKP = nil 	
					end
				end,
			order = 10
		},
}

function mod:GetOptions()
	return options
end

function mod:IsDKP()
	return true
end

function mod:GetName()
	return mod.modName, mod.modref
end

function mod:OnInitialize()
	self.db = mdkp.db:RegisterNamespace("Relational", defaults)
	
end

function mod:OnEnable()
	db = mdkp.db.profile	
	db.moduleON["Relational"] = true
	
end

function mod:OnDisable()
	db.moduleON["Relational"] = nil
end

function mod:GetPlayerPoints(name, POOL)
	if db.info[name][POOL].spent == 0 then db.info[name][POOL].spent = 1 end
	if db.info[name][POOL].earned == 0 then db.info[name][POOL].earned = 1 end
	points = fmt("%.2f", (db.info[name][POOL].earned /db.info[name][POOL].spent ))
	return points
end

function mod:GetItemValue(itemid, player, POOL)
	local itempoints = db.items[itemid].points
	if db.takemode or db.offspecmode then
		local take = db.takeamount
		local offspec = db.offspecamount
		if mdkp.querytooltips[itemid] then
			for  i,v in pairs(mdkp.querytooltips[itemid]) do
				if v[1].n == player then
					if db.takemode and v[2] == "TAKE" then 
						if db.takepercent then itempoints = itempoints * take / 100
						else itempoints = take end
					elseif db.offspecmode and v[2] == "OFFSPEC" then 
						if db.offspecpercent then itempoints = itempoints * offspec / 100
						else itempoints = offspec end
					end
					break
				end
			end
		end
	end
	itempoints = floor(itempoints + 0.5)
	return itempoints
end

function mod:ItemRecorded(id, looter, POOL, points, itempoints, link)
	if looter == L["Bank"] then return end
	points = db.info[looter][POOL].points - itempoints
	self:AwardItem(id, looter, POOL, points, itempoints, link)
end

function mod:ItemRebate(id, looter, POOL, itempoints, link)
	if not id or looter == L["Bank"] then return end
	self:AdjustDKPPoints(looter, looter, POOL, nil, itempoints)
end
